{ config, pkgs, lib, home-manager, ... } @ inputs : let
  edge = inputs.edge.outputs.legacyPackages.x86_64-linux;
in {
  users.users.calliope = { isNormalUser = true; shell = pkgs.nushell;
    extraGroups = [ "wheel" "scanner" "lp" "networkmanager" ]; };

  home-manager.users.calliope = { pkgs, config, ... }: {
    home.stateVersion = "23.11";
    fonts.fontconfig.enable = true;
    programs.nushell = { enable = true; package = edge.nushell; };

    home.packages = with pkgs; [
      usbutils
      epson-escpr2
      libsForQt5.kdeconnect-kde
    ];
    # isync neomutt #-email
  };
}
